#!/bin/bash

function die {
	echo $*
	exit 1
}

mkdir convertBakup || die "remove convertBakup"
cp * convertBakup

prob=`pushd .. >/dev/null && basename $(pwd) && popd >/dev/null `
prob=${prob:5}

function gen_Header {
echo '#ifndef __GRADER_H__' 
echo '#define __GRADER_H__' 
echo '' 
echo '#ifdef __cplusplus'
echo 'extern "C" {'
echo '#endif' 
echo ''

cat grader.h
cat $prob.h

echo ''

sed -e "s/\(.*\) \(.*\)(\(.*\))/typedef \1 (*\2Function)(\3)/g" $prob.h

echo ''
echo '#ifdef __cplusplus'
echo '}'
echo '#endif'
echo ''
echo '#endif /* __GRADER_H__ */' 
}

function gen_grader {
echo '#include "graderlib.c"'
echo ''
echo 'int main(){'
echo "    _main($mainArgNames);"
echo '}'
}

function gen_pas_grader {
echo 'program grader;'
echo ''
echo "uses $prob;"
echo ''
echo 'type'
sed -n '1,/implementation/p' $prob.pas | grep -e "function" | sed -e "s/function \([^(]*\)\(.*\)/\1Function = function \2/g"
sed -n '1,/implementation/p' $prob.pas | grep -e "procedure" | sed -e "s/procedure \([^(]*\)\(.*\)/\1Function = procedure \2/g"
echo ''
echo '{$L graderlib.o}'
echo '{$IFDEF MSWINDOWS}'
echo '{$linklib msvcrt}'
echo '{$ELSE}'
echo '{$linklib c}'
echo '{$ENDIF}'
echo ''
echo "procedure _main($mainArgsPas); cdecl; external;"
echo ''
echo 'begin'
echo "    _main($mainArgNamesPas);"
echo 'end.'
}

(gen_Header >.temp && mv .temp grader.h && rm $prob.h) || die "Error during header generation!"
diff grader.c grader.cpp || die "Which grader?"
diff $prob.c $prob.cpp || die "Which sol?"

mainArgs=`grep -e "typedef" grader.h | sed -e "s/.*(\*\([^)]*\)).*/\1/g" | sed -e "s/\(.*\)Function/\1Function \1, /g"`
mainArgs=`echo $mainArgs | sed -e "s/,$//g"`
sed -e "s/main()/_main($mainArgs)/g" grader.c | grep -ve "$prob.h"> graderlib.c
grep -ve "$prob.h" $prob.c > $prob.cpp && cp $prob.cpp $prob.c
mainArgNames=`echo $mainArgs | sed -e "s/[^ ]*Function //g"`
(gen_grader >.temp && mv .temp grader.c && cp grader.c grader.cpp) || die "Error during graders generation!"


sed -e "s/procedure .*/& cdecl;/g" $prob.pas -i
sed -e "s/function .*/& cdecl;/g" $prob.pas -i
mainArgsPas=`echo $mainArgs | sed -e "s/\([^ ]*\)Function \1/\1 : \1Function/g"`
mainArgNamesPas=`echo $mainArgs | sed -e "s/[^ ]*Function /@/g"`

rm gradershare.pas
sed -n '1,/implementation/p' graderlib.pas -i
sed -e "s/procedure .*/& cdecl; external;/g" graderlib.pas -i
sed -e "s/function .*/& cdecl; external;/g" graderlib.pas -i
echo -e "\nbegin\nend." >>graderlib.pas
mv graderlib.pas graderhelplib.pas
for i in *.pas ; do
   sed -e "s/graderlib/graderhelplib/g" $i -i
done

gen_pas_grader > grader.pas

gcc grader.c $prob.c || die "grader.c incompilable!"
g++ grader.cpp $prob.cpp || die "grader.cpp incompilable!"
gcc -c graderlib.c || die "graderlib.c incompilable!"
cp "/c/MinGW/lib/libmsvcrt.a" .
fpc grader.pas >/dev/null || die "grader.pas incompilable!"
rm *.exe *.ppu *.o libmsvcrt.a libimpgrader.a 
